<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>learn-bash</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <p>
      Bash is a name of the unix shell, which was also distributed as the shell
      for the GNU operating system and as the default shell on most Linux
      distros. Nearly all examples below can be a part of a shell script or
      executed directly in the shell.
    </p>
    <p>
      <a href="https://www.gnu.org/software/bash/manual/bashref.html"
        >Read more here.</a
      >
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb1-1" title="1"><span class="co">#!/usr/bin/env bash</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="co"># First line of the script is the shebang which tells the system how to execute</span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="co"># the script: https://en.wikipedia.org/wiki/Shebang_(Unix)</span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="co"># As you already figured, comments start with #. Shebang is also a comment.</span></a>
<a class="sourceLine" id="cb1-5" title="5"></a>
<a class="sourceLine" id="cb1-6" title="6"><span class="co"># Simple hello world example:</span></a>
<a class="sourceLine" id="cb1-7" title="7"><span class="bu">echo</span> Hello world! <span class="co"># =&gt; Hello world!</span></a>
<a class="sourceLine" id="cb1-8" title="8"></a>
<a class="sourceLine" id="cb1-9" title="9"><span class="co"># Each command starts on a new line, or after a semicolon:</span></a>
<a class="sourceLine" id="cb1-10" title="10"><span class="bu">echo</span> <span class="st">&#39;This is the first line&#39;</span><span class="kw">;</span> <span class="bu">echo</span> <span class="st">&#39;This is the second line&#39;</span></a>
<a class="sourceLine" id="cb1-11" title="11"><span class="co"># =&gt; This is the first line</span></a>
<a class="sourceLine" id="cb1-12" title="12"><span class="co"># =&gt; This is the second line</span></a>
<a class="sourceLine" id="cb1-13" title="13"></a>
<a class="sourceLine" id="cb1-14" title="14"><span class="co"># Declaring a variable looks like this:</span></a>
<a class="sourceLine" id="cb1-15" title="15"><span class="va">Variable=</span><span class="st">&quot;Some string&quot;</span></a>
<a class="sourceLine" id="cb1-16" title="16"></a>
<a class="sourceLine" id="cb1-17" title="17"><span class="co"># But not like this:</span></a>
<a class="sourceLine" id="cb1-18" title="18"><span class="ex">Variable</span> = <span class="st">&quot;Some string&quot;</span> <span class="co"># =&gt; returns error &quot;Variable: command not found&quot;</span></a>
<a class="sourceLine" id="cb1-19" title="19"><span class="co"># Bash will decide that Variable is a command it must execute and give an error</span></a>
<a class="sourceLine" id="cb1-20" title="20"><span class="co"># because it can&#39;t be found.</span></a>
<a class="sourceLine" id="cb1-21" title="21"></a>
<a class="sourceLine" id="cb1-22" title="22"><span class="co"># Nor like this:</span></a>
<a class="sourceLine" id="cb1-23" title="23"><span class="va">Variable=</span> <span class="st">&#39;Some string&#39;</span> <span class="co"># =&gt; returns error: &quot;Some string: command not found&quot;</span></a>
<a class="sourceLine" id="cb1-24" title="24"><span class="co"># Bash will decide that &#39;Some string&#39; is a command it must execute and give an</span></a>
<a class="sourceLine" id="cb1-25" title="25"><span class="co"># error because it can&#39;t be found. (In this case the &#39;Variable=&#39; part is seen</span></a>
<a class="sourceLine" id="cb1-26" title="26"><span class="co"># as a variable assignment valid only for the scope of the &#39;Some string&#39;</span></a>
<a class="sourceLine" id="cb1-27" title="27"><span class="co"># command.)</span></a>
<a class="sourceLine" id="cb1-28" title="28"></a>
<a class="sourceLine" id="cb1-29" title="29"><span class="co"># Using the variable:</span></a>
<a class="sourceLine" id="cb1-30" title="30"><span class="bu">echo</span> <span class="va">$Variable</span> <span class="co"># =&gt; Some string</span></a>
<a class="sourceLine" id="cb1-31" title="31"><span class="bu">echo</span> <span class="st">&quot;</span><span class="va">$Variable</span><span class="st">&quot;</span> <span class="co"># =&gt; Some string</span></a>
<a class="sourceLine" id="cb1-32" title="32"><span class="bu">echo</span> <span class="st">&#39;$Variable&#39;</span> <span class="co"># =&gt; $Variable</span></a>
<a class="sourceLine" id="cb1-33" title="33"><span class="co"># When you use the variable itself — assign it, export it, or else — you write</span></a>
<a class="sourceLine" id="cb1-34" title="34"><span class="co"># its name without $. If you want to use the variable&#39;s value, you should use $.</span></a>
<a class="sourceLine" id="cb1-35" title="35"><span class="co"># Note that &#39; (single quote) won&#39;t expand the variables!</span></a>
<a class="sourceLine" id="cb1-36" title="36"></a>
<a class="sourceLine" id="cb1-37" title="37"><span class="co"># Parameter expansion ${ }:</span></a>
<a class="sourceLine" id="cb1-38" title="38"><span class="bu">echo</span> <span class="va">${Variable}</span> <span class="co"># =&gt; Some string</span></a>
<a class="sourceLine" id="cb1-39" title="39"><span class="co"># This is a simple usage of parameter expansion</span></a>
<a class="sourceLine" id="cb1-40" title="40"><span class="co"># Parameter Expansion gets a value from a variable.</span></a>
<a class="sourceLine" id="cb1-41" title="41"><span class="co"># It &quot;expands&quot; or prints the value</span></a>
<a class="sourceLine" id="cb1-42" title="42"><span class="co"># During the expansion time the value or parameter can be modified</span></a>
<a class="sourceLine" id="cb1-43" title="43"><span class="co"># Below are other modifications that add onto this expansion</span></a>
<a class="sourceLine" id="cb1-44" title="44"></a>
<a class="sourceLine" id="cb1-45" title="45"><span class="co"># String substitution in variables</span></a>
<a class="sourceLine" id="cb1-46" title="46"><span class="bu">echo</span> <span class="va">${Variable/</span>Some<span class="va">/</span>A<span class="va">}</span> <span class="co"># =&gt; A string</span></a>
<a class="sourceLine" id="cb1-47" title="47"><span class="co"># This will substitute the first occurrence of &quot;Some&quot; with &quot;A&quot;</span></a>
<a class="sourceLine" id="cb1-48" title="48"></a>
<a class="sourceLine" id="cb1-49" title="49"><span class="co"># Substring from a variable</span></a>
<a class="sourceLine" id="cb1-50" title="50"><span class="va">Length=</span>7</a>
<a class="sourceLine" id="cb1-51" title="51"><span class="bu">echo</span> <span class="va">${Variable:0:Length}</span> <span class="co"># =&gt; Some st</span></a>
<a class="sourceLine" id="cb1-52" title="52"><span class="co"># This will return only the first 7 characters of the value</span></a>
<a class="sourceLine" id="cb1-53" title="53"><span class="bu">echo</span> <span class="va">${Variable: -5}</span> <span class="co"># =&gt; tring</span></a>
<a class="sourceLine" id="cb1-54" title="54"><span class="co"># This will return the last 5 characters (note the space before -5)</span></a>
<a class="sourceLine" id="cb1-55" title="55"></a>
<a class="sourceLine" id="cb1-56" title="56"><span class="co"># String length</span></a>
<a class="sourceLine" id="cb1-57" title="57"><span class="bu">echo</span> <span class="va">${#Variable}</span> <span class="co"># =&gt; 11</span></a>
<a class="sourceLine" id="cb1-58" title="58"></a>
<a class="sourceLine" id="cb1-59" title="59"><span class="co"># Indirect expansion</span></a>
<a class="sourceLine" id="cb1-60" title="60"><span class="va">OtherVariable=</span><span class="st">&quot;Variable&quot;</span></a>
<a class="sourceLine" id="cb1-61" title="61"><span class="bu">echo</span> <span class="va">${!OtherVariable}</span> <span class="co"># =&gt; Some String</span></a>
<a class="sourceLine" id="cb1-62" title="62"><span class="co"># This will expand the value of OtherVariable</span></a>
<a class="sourceLine" id="cb1-63" title="63"></a>
<a class="sourceLine" id="cb1-64" title="64"><span class="co"># Default value for variable</span></a>
<a class="sourceLine" id="cb1-65" title="65"><span class="bu">echo</span> <span class="va">${Foo:-</span><span class="st">&quot;DefaultValueIfFooIsMissingOrEmpty&quot;</span><span class="va">}</span></a>
<a class="sourceLine" id="cb1-66" title="66"><span class="co"># =&gt; DefaultValueIfFooIsMissingOrEmpty</span></a>
<a class="sourceLine" id="cb1-67" title="67"><span class="co"># This works for null (Foo=) and empty string (Foo=&quot;&quot;); zero (Foo=0) returns 0.</span></a>
<a class="sourceLine" id="cb1-68" title="68"><span class="co"># Note that it only returns default value and doesn&#39;t change variable value.</span></a>
<a class="sourceLine" id="cb1-69" title="69"></a>
<a class="sourceLine" id="cb1-70" title="70"><span class="co"># Declare an array with 6 elements</span></a>
<a class="sourceLine" id="cb1-71" title="71"><span class="va">array0=(</span>one two three four five six<span class="va">)</span></a>
<a class="sourceLine" id="cb1-72" title="72"><span class="co"># Print first element</span></a>
<a class="sourceLine" id="cb1-73" title="73"><span class="bu">echo</span> <span class="va">$array0</span> <span class="co"># =&gt; &quot;one&quot;</span></a>
<a class="sourceLine" id="cb1-74" title="74"><span class="co"># Print first element</span></a>
<a class="sourceLine" id="cb1-75" title="75"><span class="bu">echo</span> <span class="va">${array0[0]}</span> <span class="co"># =&gt; &quot;one&quot;</span></a>
<a class="sourceLine" id="cb1-76" title="76"><span class="co"># Print all elements</span></a>
<a class="sourceLine" id="cb1-77" title="77"><span class="bu">echo</span> <span class="va">${array0[@]}</span> <span class="co"># =&gt; &quot;one two three four five six&quot;</span></a>
<a class="sourceLine" id="cb1-78" title="78"><span class="co"># Print number of elements</span></a>
<a class="sourceLine" id="cb1-79" title="79"><span class="bu">echo</span> <span class="va">${#array0[@]}</span> <span class="co"># =&gt; &quot;6&quot;</span></a>
<a class="sourceLine" id="cb1-80" title="80"><span class="co"># Print number of characters in third element</span></a>
<a class="sourceLine" id="cb1-81" title="81"><span class="bu">echo</span> $<span class="dt">{#array0[2]}</span> <span class="co"># =&gt; &quot;5&quot;</span></a>
<a class="sourceLine" id="cb1-82" title="82"><span class="co"># Print 2 elements starting from forth</span></a>
<a class="sourceLine" id="cb1-83" title="83"><span class="bu">echo</span> <span class="va">${array0[@]:3:2}</span> <span class="co"># =&gt; &quot;four five&quot;</span></a>
<a class="sourceLine" id="cb1-84" title="84"><span class="co"># Print all elements. Each of them on new line.</span></a>
<a class="sourceLine" id="cb1-85" title="85"><span class="kw">for</span> <span class="ex">i</span> in <span class="st">&quot;</span><span class="va">${array0[@]}</span><span class="st">&quot;</span><span class="kw">;</span> <span class="kw">do</span></a>
<a class="sourceLine" id="cb1-86" title="86">    <span class="bu">echo</span> <span class="st">&quot;</span><span class="va">$i</span><span class="st">&quot;</span></a>
<a class="sourceLine" id="cb1-87" title="87"><span class="kw">done</span></a>
<a class="sourceLine" id="cb1-88" title="88"></a>
<a class="sourceLine" id="cb1-89" title="89"><span class="co"># Brace Expansion { }</span></a>
<a class="sourceLine" id="cb1-90" title="90"><span class="co"># Used to generate arbitrary strings</span></a>
<a class="sourceLine" id="cb1-91" title="91"><span class="bu">echo</span> <span class="dt">{1..10}</span> <span class="co"># =&gt; 1 2 3 4 5 6 7 8 9 10</span></a>
<a class="sourceLine" id="cb1-92" title="92"><span class="bu">echo</span> <span class="dt">{a..z}</span> <span class="co"># =&gt; a b c d e f g h i j k l m n o p q r s t u v w x y z</span></a>
<a class="sourceLine" id="cb1-93" title="93"><span class="co"># This will output the range from the start value to the end value</span></a>
<a class="sourceLine" id="cb1-94" title="94"></a>
<a class="sourceLine" id="cb1-95" title="95"><span class="co"># Built-in variables:</span></a>
<a class="sourceLine" id="cb1-96" title="96"><span class="co"># There are some useful built-in variables, like</span></a>
<a class="sourceLine" id="cb1-97" title="97"><span class="bu">echo</span> <span class="st">&quot;Last program&#39;s return value: </span><span class="va">$?</span><span class="st">&quot;</span></a>
<a class="sourceLine" id="cb1-98" title="98"><span class="bu">echo</span> <span class="st">&quot;Script&#39;s PID: </span><span class="va">$$</span><span class="st">&quot;</span></a>
<a class="sourceLine" id="cb1-99" title="99"><span class="bu">echo</span> <span class="st">&quot;Number of arguments passed to script: </span><span class="va">$#</span><span class="st">&quot;</span></a>
<a class="sourceLine" id="cb1-100" title="100"><span class="bu">echo</span> <span class="st">&quot;All arguments passed to script: </span><span class="va">$@</span><span class="st">&quot;</span></a>
<a class="sourceLine" id="cb1-101" title="101"><span class="bu">echo</span> <span class="st">&quot;Script&#39;s arguments separated into different variables: </span><span class="va">$1</span><span class="st"> </span><span class="va">$2</span><span class="st">...&quot;</span></a>
<a class="sourceLine" id="cb1-102" title="102"></a>
<a class="sourceLine" id="cb1-103" title="103"><span class="co"># Now that we know how to echo and use variables,</span></a>
<a class="sourceLine" id="cb1-104" title="104"><span class="co"># let&#39;s learn some of the other basics of bash!</span></a>
<a class="sourceLine" id="cb1-105" title="105"></a>
<a class="sourceLine" id="cb1-106" title="106"><span class="co"># Our current directory is available through the command `pwd`.</span></a>
<a class="sourceLine" id="cb1-107" title="107"><span class="co"># `pwd` stands for &quot;print working directory&quot;.</span></a>
<a class="sourceLine" id="cb1-108" title="108"><span class="co"># We can also use the built-in variable `$PWD`.</span></a>
<a class="sourceLine" id="cb1-109" title="109"><span class="co"># Observe that the following are equivalent:</span></a>
<a class="sourceLine" id="cb1-110" title="110"><span class="bu">echo</span> <span class="st">&quot;I&#39;m in </span><span class="va">$(</span><span class="bu">pwd</span><span class="va">)</span><span class="st">&quot;</span> <span class="co"># execs `pwd` and interpolates output</span></a>
<a class="sourceLine" id="cb1-111" title="111"><span class="bu">echo</span> <span class="st">&quot;I&#39;m in </span><span class="va">$PWD</span><span class="st">&quot;</span> <span class="co"># interpolates the variable</span></a>
<a class="sourceLine" id="cb1-112" title="112"></a>
<a class="sourceLine" id="cb1-113" title="113"><span class="co"># If you get too much output in your terminal, or from a script, the command</span></a>
<a class="sourceLine" id="cb1-114" title="114"><span class="co"># `clear` clears your screen</span></a>
<a class="sourceLine" id="cb1-115" title="115"><span class="fu">clear</span></a>
<a class="sourceLine" id="cb1-116" title="116"><span class="co"># Ctrl-L also works for clearing output</span></a>
<a class="sourceLine" id="cb1-117" title="117"></a>
<a class="sourceLine" id="cb1-118" title="118"><span class="co"># Reading a value from input:</span></a>
<a class="sourceLine" id="cb1-119" title="119"><span class="bu">echo</span> <span class="st">&quot;What&#39;s your name?&quot;</span></a>
<a class="sourceLine" id="cb1-120" title="120"><span class="bu">read</span> <span class="va">Name</span> <span class="co"># Note that we didn&#39;t need to declare a new variable</span></a>
<a class="sourceLine" id="cb1-121" title="121"><span class="bu">echo</span> Hello, <span class="va">$Name</span>!</a>
<a class="sourceLine" id="cb1-122" title="122"></a>
<a class="sourceLine" id="cb1-123" title="123"><span class="co"># We have the usual if structure:</span></a>
<a class="sourceLine" id="cb1-124" title="124"><span class="co"># use `man test` for more info about conditionals</span></a>
<a class="sourceLine" id="cb1-125" title="125"><span class="kw">if</span><span class="bu"> [</span> <span class="va">$Name</span> <span class="ot">!=</span> <span class="va">$USER</span><span class="bu"> ]</span></a>
<a class="sourceLine" id="cb1-126" title="126"><span class="kw">then</span></a>
<a class="sourceLine" id="cb1-127" title="127">    <span class="bu">echo</span> <span class="st">&quot;Your name isn&#39;t your username&quot;</span></a>
<a class="sourceLine" id="cb1-128" title="128"><span class="kw">else</span></a>
<a class="sourceLine" id="cb1-129" title="129">    <span class="bu">echo</span> <span class="st">&quot;Your name is your username&quot;</span></a>
<a class="sourceLine" id="cb1-130" title="130"><span class="kw">fi</span></a>
<a class="sourceLine" id="cb1-131" title="131"><span class="co"># True if the value of $Name is not equal to the current user&#39;s login username</span></a>
<a class="sourceLine" id="cb1-132" title="132"></a>
<a class="sourceLine" id="cb1-133" title="133"><span class="co"># </span><span class="al">NOTE</span><span class="co">: if $Name is empty, bash sees the above condition as:</span></a>
<a class="sourceLine" id="cb1-134" title="134"><span class="kw">if</span><span class="bu"> [</span> <span class="ot">!=</span> <span class="va">$USER</span><span class="bu"> ]</span></a>
<a class="sourceLine" id="cb1-135" title="135"><span class="co"># which is invalid syntax</span></a>
<a class="sourceLine" id="cb1-136" title="136"><span class="co"># so the &quot;safe&quot; way to use potentially empty variables in bash is:</span></a>
<a class="sourceLine" id="cb1-137" title="137"><span class="kw">if</span><span class="bu"> [</span> <span class="st">&quot;</span><span class="va">$Name</span><span class="st">&quot;</span> <span class="ot">!=</span> <span class="va">$USER</span><span class="bu"> ]</span> <span class="ex">...</span></a>
<a class="sourceLine" id="cb1-138" title="138"><span class="co"># which, when $Name is empty, is seen by bash as:</span></a>
<a class="sourceLine" id="cb1-139" title="139"><span class="kw">if</span><span class="bu"> [</span> <span class="st">&quot;&quot;</span> <span class="ot">!=</span> <span class="va">$USER</span><span class="bu"> ]</span> <span class="ex">...</span></a>
<a class="sourceLine" id="cb1-140" title="140"><span class="co"># which works as expected</span></a>
<a class="sourceLine" id="cb1-141" title="141"></a>
<a class="sourceLine" id="cb1-142" title="142"><span class="co"># There is also conditional execution</span></a>
<a class="sourceLine" id="cb1-143" title="143"><span class="bu">echo</span> <span class="st">&quot;Always executed&quot;</span> <span class="kw">||</span> <span class="bu">echo</span> <span class="st">&quot;Only executed if first command fails&quot;</span></a>
<a class="sourceLine" id="cb1-144" title="144"><span class="co"># =&gt; Always executed</span></a>
<a class="sourceLine" id="cb1-145" title="145"><span class="bu">echo</span> <span class="st">&quot;Always executed&quot;</span> <span class="kw">&amp;&amp;</span> <span class="bu">echo</span> <span class="st">&quot;Only executed if first command does NOT fail&quot;</span></a>
<a class="sourceLine" id="cb1-146" title="146"><span class="co"># =&gt; Always executed</span></a>
<a class="sourceLine" id="cb1-147" title="147"><span class="co"># =&gt; Only executed if first command does NOT fail</span></a>
<a class="sourceLine" id="cb1-148" title="148"></a>
<a class="sourceLine" id="cb1-149" title="149"></a>
<a class="sourceLine" id="cb1-150" title="150"><span class="co"># To use &amp;&amp; and || with if statements, you need multiple pairs of square brackets:</span></a>
<a class="sourceLine" id="cb1-151" title="151"><span class="kw">if</span><span class="bu"> [</span> <span class="st">&quot;</span><span class="va">$Name</span><span class="st">&quot;</span> <span class="ot">==</span> <span class="st">&quot;Steve&quot;</span><span class="bu"> ]</span> <span class="kw">&amp;&amp;</span><span class="bu"> [</span> <span class="st">&quot;</span><span class="va">$Age</span><span class="st">&quot;</span> <span class="ot">-eq</span> 15<span class="bu"> ]</span></a>
<a class="sourceLine" id="cb1-152" title="152"><span class="kw">then</span></a>
<a class="sourceLine" id="cb1-153" title="153">    <span class="bu">echo</span> <span class="st">&quot;This will run if </span><span class="va">$Name</span><span class="st"> is Steve AND </span><span class="va">$Age</span><span class="st"> is 15.&quot;</span></a>
<a class="sourceLine" id="cb1-154" title="154"><span class="kw">fi</span></a>
<a class="sourceLine" id="cb1-155" title="155"></a>
<a class="sourceLine" id="cb1-156" title="156"><span class="kw">if</span><span class="bu"> [</span> <span class="st">&quot;</span><span class="va">$Name</span><span class="st">&quot;</span> <span class="ot">==</span> <span class="st">&quot;Daniya&quot;</span><span class="bu"> ]</span> <span class="kw">||</span><span class="bu"> [</span> <span class="st">&quot;</span><span class="va">$Name</span><span class="st">&quot;</span> <span class="ot">==</span> <span class="st">&quot;Zach&quot;</span><span class="bu"> ]</span></a>
<a class="sourceLine" id="cb1-157" title="157"><span class="kw">then</span></a>
<a class="sourceLine" id="cb1-158" title="158">    <span class="bu">echo</span> <span class="st">&quot;This will run if </span><span class="va">$Name</span><span class="st"> is Daniya OR Zach.&quot;</span></a>
<a class="sourceLine" id="cb1-159" title="159"><span class="kw">fi</span></a>
<a class="sourceLine" id="cb1-160" title="160"></a>
<a class="sourceLine" id="cb1-161" title="161"><span class="co"># There is also the `=~` operator, which tests a string against a Regex pattern:</span></a>
<a class="sourceLine" id="cb1-162" title="162"><span class="va">Email=</span>me<span class="ex">@example.com</span></a>
<a class="sourceLine" id="cb1-163" title="163"><span class="kw">if [[</span> <span class="st">&quot;</span><span class="va">$Email</span><span class="st">&quot;</span> =~ [a-z]+@[a-z]<span class="dt">{2,}</span>\.(com|net|org)<span class="kw"> ]]</span></a>
<a class="sourceLine" id="cb1-164" title="164"><span class="kw">then</span></a>
<a class="sourceLine" id="cb1-165" title="165">    <span class="bu">echo</span> <span class="st">&quot;Valid email!&quot;</span></a>
<a class="sourceLine" id="cb1-166" title="166"><span class="kw">fi</span></a>
<a class="sourceLine" id="cb1-167" title="167"><span class="co"># Note that =~ only works within double [[ ]] square brackets,</span></a>
<a class="sourceLine" id="cb1-168" title="168"><span class="co"># which are subtly different from single [ ].</span></a>
<a class="sourceLine" id="cb1-169" title="169"><span class="co"># See https://www.gnu.org/software/bash/manual/bashref.html#Conditional-Constructs for more on this.</span></a>
<a class="sourceLine" id="cb1-170" title="170"></a>
<a class="sourceLine" id="cb1-171" title="171"><span class="co"># Redefine command `ping` as alias to send only 5 packets</span></a>
<a class="sourceLine" id="cb1-172" title="172"><span class="bu">alias</span> ping=<span class="st">&#39;ping -c 5&#39;</span></a>
<a class="sourceLine" id="cb1-173" title="173"><span class="co"># Escape the alias and use command with this name instead</span></a>
<a class="sourceLine" id="cb1-174" title="174">\<span class="fu">ping</span> 192.168.1.1</a>
<a class="sourceLine" id="cb1-175" title="175"><span class="co"># Print all aliases</span></a>
<a class="sourceLine" id="cb1-176" title="176"><span class="bu">alias</span> -p</a>
<a class="sourceLine" id="cb1-177" title="177"></a>
<a class="sourceLine" id="cb1-178" title="178"><span class="co"># Expressions are denoted with the following format:</span></a>
<a class="sourceLine" id="cb1-179" title="179"><span class="bu">echo</span> <span class="va">$((</span> 10 + 5 <span class="va">))</span> <span class="co"># =&gt; 15</span></a>
<a class="sourceLine" id="cb1-180" title="180"></a>
<a class="sourceLine" id="cb1-181" title="181"><span class="co"># Unlike other programming languages, bash is a shell so it works in the context</span></a>
<a class="sourceLine" id="cb1-182" title="182"><span class="co"># of a current directory. You can list files and directories in the current</span></a>
<a class="sourceLine" id="cb1-183" title="183"><span class="co"># directory with the ls command:</span></a>
<a class="sourceLine" id="cb1-184" title="184"><span class="fu">ls</span> <span class="co"># Lists the files and subdirectories contained in the current directory</span></a>
<a class="sourceLine" id="cb1-185" title="185"></a>
<a class="sourceLine" id="cb1-186" title="186"><span class="co"># This command has options that control its execution:</span></a>
<a class="sourceLine" id="cb1-187" title="187"><span class="fu">ls</span> -l <span class="co"># Lists every file and directory on a separate line</span></a>
<a class="sourceLine" id="cb1-188" title="188"><span class="fu">ls</span> -t <span class="co"># Sorts the directory contents by last-modified date (descending)</span></a>
<a class="sourceLine" id="cb1-189" title="189"><span class="fu">ls</span> -R <span class="co"># Recursively `ls` this directory and all of its subdirectories</span></a>
<a class="sourceLine" id="cb1-190" title="190"></a>
<a class="sourceLine" id="cb1-191" title="191"><span class="co"># Results of the previous command can be passed to the next command as input.</span></a>
<a class="sourceLine" id="cb1-192" title="192"><span class="co"># The `grep` command filters the input with provided patterns.</span></a>
<a class="sourceLine" id="cb1-193" title="193"><span class="co"># That&#39;s how we can list .txt files in the current directory:</span></a>
<a class="sourceLine" id="cb1-194" title="194"><span class="fu">ls</span> -l <span class="kw">|</span> <span class="fu">grep</span> <span class="st">&quot;\.txt&quot;</span></a>
<a class="sourceLine" id="cb1-195" title="195"></a>
<a class="sourceLine" id="cb1-196" title="196"><span class="co"># Use `cat` to print files to stdout:</span></a>
<a class="sourceLine" id="cb1-197" title="197"><span class="fu">cat</span> file.txt</a>
<a class="sourceLine" id="cb1-198" title="198"></a>
<a class="sourceLine" id="cb1-199" title="199"><span class="co"># We can also read the file using `cat`:</span></a>
<a class="sourceLine" id="cb1-200" title="200"><span class="va">Contents=$(</span><span class="fu">cat</span> file.txt<span class="va">)</span></a>
<a class="sourceLine" id="cb1-201" title="201"><span class="co"># &quot;\n&quot; prints a new line character</span></a>
<a class="sourceLine" id="cb1-202" title="202"><span class="co"># &quot;-e&quot; to interpret the newline escape characters as escape characters</span></a>
<a class="sourceLine" id="cb1-203" title="203"><span class="bu">echo</span> -e <span class="st">&quot;START OF FILE\n</span><span class="va">$Contents</span><span class="st">\nEND OF FILE&quot;</span></a>
<a class="sourceLine" id="cb1-204" title="204"><span class="co"># =&gt; START OF FILE</span></a>
<a class="sourceLine" id="cb1-205" title="205"><span class="co"># =&gt; [contents of file.txt]</span></a>
<a class="sourceLine" id="cb1-206" title="206"><span class="co"># =&gt; </span><span class="re">END</span><span class="co"> OF FILE</span></a>
<a class="sourceLine" id="cb1-207" title="207"></a>
<a class="sourceLine" id="cb1-208" title="208"><span class="co"># Use `cp` to copy files or directories from one place to another.</span></a>
<a class="sourceLine" id="cb1-209" title="209"><span class="co"># `cp` creates NEW versions of the sources,</span></a>
<a class="sourceLine" id="cb1-210" title="210"><span class="co"># so editing the copy won&#39;t affect the original (and vice versa).</span></a>
<a class="sourceLine" id="cb1-211" title="211"><span class="co"># Note that it will overwrite the destination if it already exists.</span></a>
<a class="sourceLine" id="cb1-212" title="212"><span class="fu">cp</span> srcFile.txt clone.txt</a>
<a class="sourceLine" id="cb1-213" title="213"><span class="fu">cp</span> -r srcDirectory/ dst/ <span class="co"># recursively copy</span></a>
<a class="sourceLine" id="cb1-214" title="214"></a>
<a class="sourceLine" id="cb1-215" title="215"><span class="co"># Look into `scp` or `sftp` if you plan on exchanging files between computers.</span></a>
<a class="sourceLine" id="cb1-216" title="216"><span class="co"># `scp` behaves very similarly to `cp`.</span></a>
<a class="sourceLine" id="cb1-217" title="217"><span class="co"># `sftp` is more interactive.</span></a>
<a class="sourceLine" id="cb1-218" title="218"></a>
<a class="sourceLine" id="cb1-219" title="219"><span class="co"># Use `mv` to move files or directories from one place to another.</span></a>
<a class="sourceLine" id="cb1-220" title="220"><span class="co"># `mv` is similar to `cp`, but it deletes the source.</span></a>
<a class="sourceLine" id="cb1-221" title="221"><span class="co"># `mv` is also useful for renaming files!</span></a>
<a class="sourceLine" id="cb1-222" title="222"><span class="fu">mv</span> s0urc3.txt dst.txt <span class="co"># sorry, l33t hackers...</span></a>
<a class="sourceLine" id="cb1-223" title="223"></a>
<a class="sourceLine" id="cb1-224" title="224"><span class="co"># Since bash works in the context of a current directory, you might want to</span></a>
<a class="sourceLine" id="cb1-225" title="225"><span class="co"># run your command in some other directory. We have cd for changing location:</span></a>
<a class="sourceLine" id="cb1-226" title="226"><span class="bu">cd</span> ~    <span class="co"># change to home directory</span></a>
<a class="sourceLine" id="cb1-227" title="227"><span class="bu">cd</span>      <span class="co"># also goes to home directory</span></a>
<a class="sourceLine" id="cb1-228" title="228"><span class="bu">cd</span> ..   <span class="co"># go up one directory</span></a>
<a class="sourceLine" id="cb1-229" title="229">        <span class="co"># (^^say, from /home/username/Downloads to /home/username)</span></a>
<a class="sourceLine" id="cb1-230" title="230"><span class="bu">cd</span> /home/username/Documents   <span class="co"># change to specified directory</span></a>
<a class="sourceLine" id="cb1-231" title="231"><span class="bu">cd</span> ~/Documents/..    <span class="co"># still in home directory..isn&#39;t it??</span></a>
<a class="sourceLine" id="cb1-232" title="232"><span class="bu">cd</span> -    <span class="co"># change to last directory</span></a>
<a class="sourceLine" id="cb1-233" title="233"><span class="co"># =&gt; /home/username/Documents</span></a>
<a class="sourceLine" id="cb1-234" title="234"></a>
<a class="sourceLine" id="cb1-235" title="235"><span class="co"># Use subshells to work across directories</span></a>
<a class="sourceLine" id="cb1-236" title="236"><span class="kw">(</span><span class="bu">echo</span> <span class="st">&quot;First, I&#39;m here: </span><span class="va">$PWD</span><span class="st">&quot;</span><span class="kw">)</span> <span class="kw">&amp;&amp;</span> <span class="kw">(</span><span class="bu">cd</span> someDir<span class="kw">;</span> <span class="bu">echo</span> <span class="st">&quot;Then, I&#39;m here: </span><span class="va">$PWD</span><span class="st">&quot;</span><span class="kw">)</span></a>
<a class="sourceLine" id="cb1-237" title="237"><span class="bu">pwd</span> <span class="co"># still in first directory</span></a>
<a class="sourceLine" id="cb1-238" title="238"></a>
<a class="sourceLine" id="cb1-239" title="239"><span class="co"># Use `mkdir` to create new directories.</span></a>
<a class="sourceLine" id="cb1-240" title="240"><span class="fu">mkdir</span> myNewDir</a>
<a class="sourceLine" id="cb1-241" title="241"><span class="co"># The `-p` flag causes new intermediate directories to be created as necessary.</span></a>
<a class="sourceLine" id="cb1-242" title="242"><span class="fu">mkdir</span> -p myNewDir/with/intermediate/directories</a>
<a class="sourceLine" id="cb1-243" title="243"><span class="co"># if the intermediate directories didn&#39;t already exist, running the above</span></a>
<a class="sourceLine" id="cb1-244" title="244"><span class="co"># command without the `-p` flag would return an error</span></a>
<a class="sourceLine" id="cb1-245" title="245"></a>
<a class="sourceLine" id="cb1-246" title="246"><span class="co"># You can redirect command input and output (stdin, stdout, and stderr).</span></a>
<a class="sourceLine" id="cb1-247" title="247"><span class="co"># Read from stdin until ^EOF$ and overwrite hello.py with the lines</span></a>
<a class="sourceLine" id="cb1-248" title="248"><span class="co"># between &quot;EOF&quot;:</span></a>
<a class="sourceLine" id="cb1-249" title="249"><span class="fu">cat</span> <span class="op">&gt;</span> hello.py <span class="op">&lt;&lt; EOF</span></a>
<a class="sourceLine" id="cb1-250" title="250">#!/usr/bin/env python</a>
<a class="sourceLine" id="cb1-251" title="251">from __future__ import print_function</a>
<a class="sourceLine" id="cb1-252" title="252">import sys</a>
<a class="sourceLine" id="cb1-253" title="253">print(&quot;#stdout&quot;, file=sys.stdout)</a>
<a class="sourceLine" id="cb1-254" title="254">print(&quot;#stderr&quot;, file=sys.stderr)</a>
<a class="sourceLine" id="cb1-255" title="255">for line in sys.stdin:</a>
<a class="sourceLine" id="cb1-256" title="256">    print(line, file=sys.stdout)</a>
<a class="sourceLine" id="cb1-257" title="257"><span class="op">EOF</span></a>
<a class="sourceLine" id="cb1-258" title="258"><span class="co"># Variables will be expanded if the first &quot;EOF&quot; is not quoted</span></a>
<a class="sourceLine" id="cb1-259" title="259"></a>
<a class="sourceLine" id="cb1-260" title="260"><span class="co"># Run the hello.py Python script with various stdin, stdout, and</span></a>
<a class="sourceLine" id="cb1-261" title="261"><span class="co"># stderr redirections:</span></a>
<a class="sourceLine" id="cb1-262" title="262"><span class="ex">python</span> hello.py <span class="op">&lt;</span> <span class="st">&quot;input.in&quot;</span> <span class="co"># pass input.in as input to the script</span></a>
<a class="sourceLine" id="cb1-263" title="263"></a>
<a class="sourceLine" id="cb1-264" title="264"><span class="ex">python</span> hello.py <span class="op">&gt;</span> <span class="st">&quot;output.out&quot;</span> <span class="co"># redirect output from the script to output.out</span></a>
<a class="sourceLine" id="cb1-265" title="265"></a>
<a class="sourceLine" id="cb1-266" title="266"><span class="ex">python</span> hello.py <span class="op">2&gt;</span> <span class="st">&quot;error.err&quot;</span> <span class="co"># redirect error output to error.err</span></a>
<a class="sourceLine" id="cb1-267" title="267"></a>
<a class="sourceLine" id="cb1-268" title="268"><span class="ex">python</span> hello.py <span class="op">&gt;</span> <span class="st">&quot;output-and-error.log&quot;</span> <span class="op">2&gt;&amp;1</span></a>
<a class="sourceLine" id="cb1-269" title="269"><span class="co"># redirect both output and errors to output-and-error.log</span></a>
<a class="sourceLine" id="cb1-270" title="270"></a>
<a class="sourceLine" id="cb1-271" title="271"><span class="ex">python</span> hello.py <span class="op">&gt;</span> /dev/null <span class="op">2&gt;&amp;1</span></a>
<a class="sourceLine" id="cb1-272" title="272"><span class="co"># redirect all output and errors to the black hole, /dev/null, i.e., no output</span></a>
<a class="sourceLine" id="cb1-273" title="273"></a>
<a class="sourceLine" id="cb1-274" title="274"><span class="co"># The output error will overwrite the file if it exists,</span></a>
<a class="sourceLine" id="cb1-275" title="275"><span class="co"># if you want to append instead, use &quot;&gt;&gt;&quot;:</span></a>
<a class="sourceLine" id="cb1-276" title="276"><span class="ex">python</span> hello.py <span class="op">&gt;&gt;</span> <span class="st">&quot;output.out&quot;</span> <span class="op">2&gt;&gt;</span> <span class="st">&quot;error.err&quot;</span></a>
<a class="sourceLine" id="cb1-277" title="277"></a>
<a class="sourceLine" id="cb1-278" title="278"><span class="co"># Overwrite output.out, append to error.err, and count lines:</span></a>
<a class="sourceLine" id="cb1-279" title="279"><span class="ex">info</span> bash <span class="st">&#39;Basic Shell Features&#39;</span> <span class="st">&#39;Redirections&#39;</span> <span class="op">&gt;</span> output.out <span class="op">2&gt;&gt;</span> error.err</a>
<a class="sourceLine" id="cb1-280" title="280"><span class="fu">wc</span> -l output.out error.err</a>
<a class="sourceLine" id="cb1-281" title="281"></a>
<a class="sourceLine" id="cb1-282" title="282"><span class="co"># Run a command and print its file descriptor (e.g. /dev/fd/123)</span></a>
<a class="sourceLine" id="cb1-283" title="283"><span class="co"># see: man fd</span></a>
<a class="sourceLine" id="cb1-284" title="284"><span class="bu">echo</span> <span class="op">&lt;(</span><span class="bu">echo</span> <span class="st">&quot;#helloworld&quot;</span><span class="op">)</span></a>
<a class="sourceLine" id="cb1-285" title="285"></a>
<a class="sourceLine" id="cb1-286" title="286"><span class="co"># Overwrite output.out with &quot;#helloworld&quot;:</span></a>
<a class="sourceLine" id="cb1-287" title="287"><span class="fu">cat</span> <span class="op">&gt;</span> output.out <span class="op">&lt;(</span><span class="bu">echo</span> <span class="st">&quot;#helloworld&quot;</span><span class="op">)</span></a>
<a class="sourceLine" id="cb1-288" title="288"><span class="bu">echo</span> <span class="st">&quot;#helloworld&quot;</span> <span class="op">&gt;</span> output.out</a>
<a class="sourceLine" id="cb1-289" title="289"><span class="bu">echo</span> <span class="st">&quot;#helloworld&quot;</span> <span class="kw">|</span> <span class="fu">cat</span> <span class="op">&gt;</span> output.out</a>
<a class="sourceLine" id="cb1-290" title="290"><span class="bu">echo</span> <span class="st">&quot;#helloworld&quot;</span> <span class="kw">|</span> <span class="fu">tee</span> output.out <span class="op">&gt;</span>/dev/null</a>
<a class="sourceLine" id="cb1-291" title="291"></a>
<a class="sourceLine" id="cb1-292" title="292"><span class="co"># Cleanup temporary files verbosely (add &#39;-i&#39; for interactive)</span></a>
<a class="sourceLine" id="cb1-293" title="293"><span class="co"># </span><span class="al">WARNING</span><span class="co">: `rm` commands cannot be undone</span></a>
<a class="sourceLine" id="cb1-294" title="294"><span class="fu">rm</span> -v output.out error.err output-and-error.log</a>
<a class="sourceLine" id="cb1-295" title="295"><span class="fu">rm</span> -r tempDir/ <span class="co"># recursively delete</span></a>
<a class="sourceLine" id="cb1-296" title="296"><span class="co"># You can install the `trash-cli` Python package to have `trash`</span></a>
<a class="sourceLine" id="cb1-297" title="297"><span class="co"># which puts files in the system trash and doesn&#39;t delete them directly</span></a>
<a class="sourceLine" id="cb1-298" title="298"><span class="co"># see https://pypi.org/project/trash-cli/ if you want to be careful</span></a>
<a class="sourceLine" id="cb1-299" title="299"></a>
<a class="sourceLine" id="cb1-300" title="300"><span class="co"># Commands can be substituted within other commands using $( ):</span></a>
<a class="sourceLine" id="cb1-301" title="301"><span class="co"># The following command displays the number of files and directories in the</span></a>
<a class="sourceLine" id="cb1-302" title="302"><span class="co"># current directory.</span></a>
<a class="sourceLine" id="cb1-303" title="303"><span class="bu">echo</span> <span class="st">&quot;There are </span><span class="va">$(</span><span class="fu">ls</span> <span class="kw">|</span> <span class="fu">wc</span> -l<span class="va">)</span><span class="st"> items here.&quot;</span></a>
<a class="sourceLine" id="cb1-304" title="304"></a>
<a class="sourceLine" id="cb1-305" title="305"><span class="co"># The same can be done using backticks `` but they can&#39;t be nested -</span></a>
<a class="sourceLine" id="cb1-306" title="306"><span class="co"># the preferred way is to use $( ).</span></a>
<a class="sourceLine" id="cb1-307" title="307"><span class="bu">echo</span> <span class="st">&quot;There are </span><span class="kw">`</span><span class="fu">ls</span> <span class="kw">|</span> <span class="fu">wc</span> -l<span class="kw">`</span><span class="st"> items here.&quot;</span></a>
<a class="sourceLine" id="cb1-308" title="308"></a>
<a class="sourceLine" id="cb1-309" title="309"><span class="co"># Bash uses a `case` statement that works similarly to switch in Java and C++:</span></a>
<a class="sourceLine" id="cb1-310" title="310"><span class="kw">case</span> <span class="st">&quot;</span><span class="va">$Variable</span><span class="st">&quot;</span><span class="kw"> in</span></a>
<a class="sourceLine" id="cb1-311" title="311">    <span class="co"># List patterns for the conditions you want to meet</span></a>
<a class="sourceLine" id="cb1-312" title="312">    0<span class="kw">)</span> <span class="bu">echo</span> <span class="st">&quot;There is a zero.&quot;</span><span class="kw">;;</span></a>
<a class="sourceLine" id="cb1-313" title="313">    <span class="ex">1</span>) <span class="bu">echo</span> <span class="st">&quot;There is a one.&quot;</span><span class="kw">;;</span></a>
<a class="sourceLine" id="cb1-314" title="314">    <span class="ex">*</span>) <span class="bu">echo</span> <span class="st">&quot;It is not null.&quot;</span><span class="kw">;;</span>  <span class="co"># match everything</span></a>
<a class="sourceLine" id="cb1-315" title="315"><span class="kw">esac</span></a>
<a class="sourceLine" id="cb1-316" title="316"></a>
<a class="sourceLine" id="cb1-317" title="317"><span class="co"># `for` loops iterate for as many arguments given:</span></a>
<a class="sourceLine" id="cb1-318" title="318"><span class="co"># The contents of $Variable is printed three times.</span></a>
<a class="sourceLine" id="cb1-319" title="319"><span class="kw">for</span> <span class="ex">Variable</span> in <span class="dt">{1..3}</span></a>
<a class="sourceLine" id="cb1-320" title="320"><span class="kw">do</span></a>
<a class="sourceLine" id="cb1-321" title="321">    <span class="bu">echo</span> <span class="st">&quot;</span><span class="va">$Variable</span><span class="st">&quot;</span></a>
<a class="sourceLine" id="cb1-322" title="322"><span class="kw">done</span></a>
<a class="sourceLine" id="cb1-323" title="323"><span class="co"># =&gt; 1</span></a>
<a class="sourceLine" id="cb1-324" title="324"><span class="co"># =&gt; 2</span></a>
<a class="sourceLine" id="cb1-325" title="325"><span class="co"># =&gt; 3</span></a>
<a class="sourceLine" id="cb1-326" title="326"></a>
<a class="sourceLine" id="cb1-327" title="327"></a>
<a class="sourceLine" id="cb1-328" title="328"><span class="co"># Or write it the &quot;traditional for loop&quot; way:</span></a>
<a class="sourceLine" id="cb1-329" title="329"><span class="kw">for</span> <span class="kw">((</span>a=1; a &lt;= 3; a++<span class="kw">))</span></a>
<a class="sourceLine" id="cb1-330" title="330"><span class="kw">do</span></a>
<a class="sourceLine" id="cb1-331" title="331">    <span class="bu">echo</span> <span class="va">$a</span></a>
<a class="sourceLine" id="cb1-332" title="332"><span class="kw">done</span></a>
<a class="sourceLine" id="cb1-333" title="333"><span class="co"># =&gt; 1</span></a>
<a class="sourceLine" id="cb1-334" title="334"><span class="co"># =&gt; 2</span></a>
<a class="sourceLine" id="cb1-335" title="335"><span class="co"># =&gt; 3</span></a>
<a class="sourceLine" id="cb1-336" title="336"></a>
<a class="sourceLine" id="cb1-337" title="337"><span class="co"># They can also be used to act on files..</span></a>
<a class="sourceLine" id="cb1-338" title="338"><span class="co"># This will run the command `cat` on file1 and file2</span></a>
<a class="sourceLine" id="cb1-339" title="339"><span class="kw">for</span> <span class="ex">Variable</span> in file1 file2</a>
<a class="sourceLine" id="cb1-340" title="340"><span class="kw">do</span></a>
<a class="sourceLine" id="cb1-341" title="341">    <span class="fu">cat</span> <span class="st">&quot;</span><span class="va">$Variable</span><span class="st">&quot;</span></a>
<a class="sourceLine" id="cb1-342" title="342"><span class="kw">done</span></a>
<a class="sourceLine" id="cb1-343" title="343"></a>
<a class="sourceLine" id="cb1-344" title="344"><span class="co"># ..or the output from a command</span></a>
<a class="sourceLine" id="cb1-345" title="345"><span class="co"># This will `cat` the output from `ls`.</span></a>
<a class="sourceLine" id="cb1-346" title="346"><span class="kw">for</span> <span class="ex">Output</span> in <span class="va">$(</span><span class="fu">ls</span><span class="va">)</span></a>
<a class="sourceLine" id="cb1-347" title="347"><span class="kw">do</span></a>
<a class="sourceLine" id="cb1-348" title="348">    <span class="fu">cat</span> <span class="st">&quot;</span><span class="va">$Output</span><span class="st">&quot;</span></a>
<a class="sourceLine" id="cb1-349" title="349"><span class="kw">done</span></a>
<a class="sourceLine" id="cb1-350" title="350"></a>
<a class="sourceLine" id="cb1-351" title="351"><span class="co"># Bash can also accept patterns, like this to `cat`</span></a>
<a class="sourceLine" id="cb1-352" title="352"><span class="co"># all the Markdown files in current directory</span></a>
<a class="sourceLine" id="cb1-353" title="353"><span class="kw">for</span> <span class="ex">Output</span> in ./*.markdown</a>
<a class="sourceLine" id="cb1-354" title="354"><span class="kw">do</span></a>
<a class="sourceLine" id="cb1-355" title="355">    <span class="fu">cat</span> <span class="st">&quot;</span><span class="va">$Output</span><span class="st">&quot;</span></a>
<a class="sourceLine" id="cb1-356" title="356"><span class="kw">done</span></a>
<a class="sourceLine" id="cb1-357" title="357"></a>
<a class="sourceLine" id="cb1-358" title="358"><span class="co"># while loop:</span></a>
<a class="sourceLine" id="cb1-359" title="359"><span class="kw">while</span><span class="bu"> [</span> true<span class="bu"> ]</span></a>
<a class="sourceLine" id="cb1-360" title="360"><span class="kw">do</span></a>
<a class="sourceLine" id="cb1-361" title="361">    <span class="bu">echo</span> <span class="st">&quot;loop body here...&quot;</span></a>
<a class="sourceLine" id="cb1-362" title="362">    <span class="bu">break</span></a>
<a class="sourceLine" id="cb1-363" title="363"><span class="kw">done</span></a>
<a class="sourceLine" id="cb1-364" title="364"><span class="co"># =&gt; loop body here...</span></a>
<a class="sourceLine" id="cb1-365" title="365"></a>
<a class="sourceLine" id="cb1-366" title="366"><span class="co"># You can also define functions</span></a>
<a class="sourceLine" id="cb1-367" title="367"><span class="co"># Definition:</span></a>
<a class="sourceLine" id="cb1-368" title="368"><span class="kw">function</span><span class="fu"> foo ()</span></a>
<a class="sourceLine" id="cb1-369" title="369"><span class="kw">{</span></a>
<a class="sourceLine" id="cb1-370" title="370">    <span class="bu">echo</span> <span class="st">&quot;Arguments work just like script arguments: </span><span class="va">$@</span><span class="st">&quot;</span></a>
<a class="sourceLine" id="cb1-371" title="371">    <span class="bu">echo</span> <span class="st">&quot;And: </span><span class="va">$1</span><span class="st"> </span><span class="va">$2</span><span class="st">...&quot;</span></a>
<a class="sourceLine" id="cb1-372" title="372">    <span class="bu">echo</span> <span class="st">&quot;This is a function&quot;</span></a>
<a class="sourceLine" id="cb1-373" title="373">    <span class="bu">return</span> 0</a>
<a class="sourceLine" id="cb1-374" title="374"><span class="kw">}</span></a>
<a class="sourceLine" id="cb1-375" title="375"><span class="co"># Call the function `foo` with two arguments, arg1 and arg2:</span></a>
<a class="sourceLine" id="cb1-376" title="376"><span class="ex">foo</span> arg1 arg2</a>
<a class="sourceLine" id="cb1-377" title="377"><span class="co"># =&gt; Arguments work just like script arguments: arg1 arg2</span></a>
<a class="sourceLine" id="cb1-378" title="378"><span class="co"># =&gt; And: arg1 arg2...</span></a>
<a class="sourceLine" id="cb1-379" title="379"><span class="co"># =&gt; This is a function</span></a>
<a class="sourceLine" id="cb1-380" title="380"></a>
<a class="sourceLine" id="cb1-381" title="381"><span class="co"># or simply</span></a>
<a class="sourceLine" id="cb1-382" title="382"><span class="fu">bar ()</span></a>
<a class="sourceLine" id="cb1-383" title="383"><span class="kw">{</span></a>
<a class="sourceLine" id="cb1-384" title="384">    <span class="bu">echo</span> <span class="st">&quot;Another way to declare functions!&quot;</span></a>
<a class="sourceLine" id="cb1-385" title="385">    <span class="bu">return</span> 0</a>
<a class="sourceLine" id="cb1-386" title="386"><span class="kw">}</span></a>
<a class="sourceLine" id="cb1-387" title="387"><span class="co"># Call the function `bar` with no arguments:</span></a>
<a class="sourceLine" id="cb1-388" title="388"><span class="ex">bar</span> <span class="co"># =&gt; Another way to declare functions!</span></a>
<a class="sourceLine" id="cb1-389" title="389"></a>
<a class="sourceLine" id="cb1-390" title="390"><span class="co"># Calling your function</span></a>
<a class="sourceLine" id="cb1-391" title="391"><span class="ex">foo</span> <span class="st">&quot;My name is&quot;</span> <span class="va">$Name</span></a>
<a class="sourceLine" id="cb1-392" title="392"></a>
<a class="sourceLine" id="cb1-393" title="393"><span class="co"># There are a lot of useful commands you should learn:</span></a>
<a class="sourceLine" id="cb1-394" title="394"><span class="co"># prints last 10 lines of file.txt</span></a>
<a class="sourceLine" id="cb1-395" title="395"><span class="fu">tail</span> -n 10 file.txt</a>
<a class="sourceLine" id="cb1-396" title="396"></a>
<a class="sourceLine" id="cb1-397" title="397"><span class="co"># prints first 10 lines of file.txt</span></a>
<a class="sourceLine" id="cb1-398" title="398"><span class="fu">head</span> -n 10 file.txt</a>
<a class="sourceLine" id="cb1-399" title="399"></a>
<a class="sourceLine" id="cb1-400" title="400"><span class="co"># sort file.txt&#39;s lines</span></a>
<a class="sourceLine" id="cb1-401" title="401"><span class="fu">sort</span> file.txt</a>
<a class="sourceLine" id="cb1-402" title="402"></a>
<a class="sourceLine" id="cb1-403" title="403"><span class="co"># report or omit repeated lines, with -d it reports them</span></a>
<a class="sourceLine" id="cb1-404" title="404"><span class="fu">uniq</span> -d file.txt</a>
<a class="sourceLine" id="cb1-405" title="405"></a>
<a class="sourceLine" id="cb1-406" title="406"><span class="co"># prints only the first column before the &#39;,&#39; character</span></a>
<a class="sourceLine" id="cb1-407" title="407"><span class="fu">cut</span> -d <span class="st">&#39;,&#39;</span> -f 1 file.txt</a>
<a class="sourceLine" id="cb1-408" title="408"></a>
<a class="sourceLine" id="cb1-409" title="409"><span class="co"># replaces every occurrence of &#39;okay&#39; with &#39;great&#39; in file.txt</span></a>
<a class="sourceLine" id="cb1-410" title="410"><span class="co"># (regex compatible)</span></a>
<a class="sourceLine" id="cb1-411" title="411"><span class="fu">sed</span> -i <span class="st">&#39;s/okay/great/g&#39;</span> file.txt</a>
<a class="sourceLine" id="cb1-412" title="412"><span class="co"># be aware that this -i flag means that file.txt will be changed</span></a>
<a class="sourceLine" id="cb1-413" title="413"><span class="co"># -i or --in-place erase the input file (use --in-place=.backup to keep a back-up)</span></a>
<a class="sourceLine" id="cb1-414" title="414"></a>
<a class="sourceLine" id="cb1-415" title="415"><span class="co"># print to stdout all lines of file.txt which match some regex</span></a>
<a class="sourceLine" id="cb1-416" title="416"><span class="co"># The example prints lines which begin with &quot;foo&quot; and end in &quot;bar&quot;</span></a>
<a class="sourceLine" id="cb1-417" title="417"><span class="fu">grep</span> <span class="st">&quot;^foo.*bar$&quot;</span> file.txt</a>
<a class="sourceLine" id="cb1-418" title="418"></a>
<a class="sourceLine" id="cb1-419" title="419"><span class="co"># pass the option &quot;-c&quot; to instead print the number of lines matching the regex</span></a>
<a class="sourceLine" id="cb1-420" title="420"><span class="fu">grep</span> -c <span class="st">&quot;^foo.*bar$&quot;</span> file.txt</a>
<a class="sourceLine" id="cb1-421" title="421"></a>
<a class="sourceLine" id="cb1-422" title="422"><span class="co"># Other useful options are:</span></a>
<a class="sourceLine" id="cb1-423" title="423"><span class="fu">grep</span> -r <span class="st">&quot;^foo.*bar$&quot;</span> someDir/ <span class="co"># recursively `grep`</span></a>
<a class="sourceLine" id="cb1-424" title="424"><span class="fu">grep</span> -n <span class="st">&quot;^foo.*bar$&quot;</span> file.txt <span class="co"># give line numbers</span></a>
<a class="sourceLine" id="cb1-425" title="425"><span class="fu">grep</span> -rI <span class="st">&quot;^foo.*bar$&quot;</span> someDir/ <span class="co"># recursively `grep`, but ignore binary files</span></a>
<a class="sourceLine" id="cb1-426" title="426"></a>
<a class="sourceLine" id="cb1-427" title="427"><span class="co"># perform the same initial search, but filter out the lines containing &quot;baz&quot;</span></a>
<a class="sourceLine" id="cb1-428" title="428"><span class="fu">grep</span> <span class="st">&quot;^foo.*bar$&quot;</span> file.txt <span class="kw">|</span> <span class="fu">grep</span> -v <span class="st">&quot;baz&quot;</span></a>
<a class="sourceLine" id="cb1-429" title="429"></a>
<a class="sourceLine" id="cb1-430" title="430"><span class="co"># if you literally want to search for the string,</span></a>
<a class="sourceLine" id="cb1-431" title="431"><span class="co"># and not the regex, use `fgrep` (or `grep -F`)</span></a>
<a class="sourceLine" id="cb1-432" title="432"><span class="fu">fgrep</span> <span class="st">&quot;foobar&quot;</span> file.txt</a>
<a class="sourceLine" id="cb1-433" title="433"></a>
<a class="sourceLine" id="cb1-434" title="434"><span class="co"># The `trap` command allows you to execute a command whenever your script</span></a>
<a class="sourceLine" id="cb1-435" title="435"><span class="co"># receives a signal. Here, `trap` will execute `rm` if it receives any of the</span></a>
<a class="sourceLine" id="cb1-436" title="436"><span class="co"># three listed signals.</span></a>
<a class="sourceLine" id="cb1-437" title="437"><span class="bu">trap</span> <span class="st">&quot;rm </span><span class="va">$TEMP_FILE</span><span class="st">; exit&quot;</span> SIGHUP SIGINT SIGTERM</a>
<a class="sourceLine" id="cb1-438" title="438"></a>
<a class="sourceLine" id="cb1-439" title="439"><span class="co"># `sudo` is used to perform commands as the superuser</span></a>
<a class="sourceLine" id="cb1-440" title="440"><span class="co"># usually it will ask interactively the password of superuser</span></a>
<a class="sourceLine" id="cb1-441" title="441"><span class="va">NAME1=$(</span><span class="fu">whoami</span><span class="va">)</span></a>
<a class="sourceLine" id="cb1-442" title="442"><span class="va">NAME2=$(</span><span class="fu">sudo</span> whoami<span class="va">)</span></a>
<a class="sourceLine" id="cb1-443" title="443"><span class="bu">echo</span> <span class="st">&quot;Was </span><span class="va">$NAME1</span><span class="st">, then became more powerful </span><span class="va">$NAME2</span><span class="st">&quot;</span></a>
<a class="sourceLine" id="cb1-444" title="444"></a>
<a class="sourceLine" id="cb1-445" title="445"><span class="co"># Read Bash shell built-ins documentation with the bash `help` built-in:</span></a>
<a class="sourceLine" id="cb1-446" title="446"><span class="bu">help</span></a>
<a class="sourceLine" id="cb1-447" title="447"><span class="bu">help</span> help</a>
<a class="sourceLine" id="cb1-448" title="448"><span class="bu">help</span> for</a>
<a class="sourceLine" id="cb1-449" title="449"><span class="bu">help</span> return</a>
<a class="sourceLine" id="cb1-450" title="450"><span class="bu">help</span> source</a>
<a class="sourceLine" id="cb1-451" title="451"><span class="bu">help</span> .</a>
<a class="sourceLine" id="cb1-452" title="452"></a>
<a class="sourceLine" id="cb1-453" title="453"><span class="co"># Read Bash manpage documentation with `man`</span></a>
<a class="sourceLine" id="cb1-454" title="454"><span class="fu">apropos</span> bash</a>
<a class="sourceLine" id="cb1-455" title="455"><span class="fu">man</span> 1 bash</a>
<a class="sourceLine" id="cb1-456" title="456"><span class="fu">man</span> bash</a>
<a class="sourceLine" id="cb1-457" title="457"></a>
<a class="sourceLine" id="cb1-458" title="458"><span class="co"># Read info documentation with `info` (`?` for help)</span></a>
<a class="sourceLine" id="cb1-459" title="459"><span class="fu">apropos</span> info <span class="kw">|</span> <span class="fu">grep</span> <span class="st">&#39;^info.*(&#39;</span></a>
<a class="sourceLine" id="cb1-460" title="460"><span class="fu">man</span> info</a>
<a class="sourceLine" id="cb1-461" title="461"><span class="ex">info</span> info</a>
<a class="sourceLine" id="cb1-462" title="462"><span class="ex">info</span> 5 info</a>
<a class="sourceLine" id="cb1-463" title="463"></a>
<a class="sourceLine" id="cb1-464" title="464"><span class="co"># Read bash info documentation:</span></a>
<a class="sourceLine" id="cb1-465" title="465"><span class="ex">info</span> bash</a>
<a class="sourceLine" id="cb1-466" title="466"><span class="ex">info</span> bash <span class="st">&#39;Bash Features&#39;</span></a>
<a class="sourceLine" id="cb1-467" title="467"><span class="ex">info</span> bash 6</a>
<a class="sourceLine" id="cb1-468" title="468"><span class="ex">info</span> --apropos bash</a></code></pre>
    </div>
  </body>
</html>
